| The Gaudi Framework v32r1 (f65d50dc)

Classes | Public Member Functions | List of all members
IRndmGen Class Referenceabstract

Definition of a interface for a generic random number generators. More...

`#include <GaudiKernel/IRndmGen.h>`

Inheritance diagram for IRndmGen:
[legend]
Collaboration diagram for IRndmGen:
[legend]

## Classes
class | Param

## Public Member Functions
| DeclareInterfaceID (IRndmGen, 2, 0)
| InterfaceID. More...
virtual StatusCode | initialize (const IRndmGen::Param &par)=0
| Initialize the generator. More...
virtual StatusCode | finalize ()=0
| Finalize the generator. More...
virtual const InterfaceID & | type () const =0
| Random number generator type. More...
virtual long | ID () const =0
| Random generator ID. More...
virtual const IRndmGen::Param * | parameters () const =0
| Access to random number generator parameters. More...
virtual double | shoot () const =0
| Single shot returning single random number according to specified distribution. More...
virtual StatusCode | shootArray (std::vector< double > &array, long howmany, long start=0) const =0
| Multiple shots returning vector with random number according to specified distribution. More...
virtual | ~IRndmGen ()=default
| Virtual destructor. More...
Public Member Functions inherited from IInterface
virtual void * | i_cast (const InterfaceID &) const =0
| main cast function More...
virtual std::vector< std::string > | getInterfaceNames () const =0
| Returns a vector of strings containing the names of all the implemented interfaces. More...
virtual unsigned long | addRef ()=0
| Increment the reference count of Interface instance. More...
virtual unsigned long | release ()=0
| Release Interface instance. More...
virtual unsigned long | refCount () const =0
| Current reference count. More...
virtual StatusCode | queryInterface (const InterfaceID &ti, void **pp)=0
| Set the void** to the pointer to the requested interface of the instance. More...
virtual | ~IInterface ()=default
| Virtual destructor. More...

## Additional Inherited Members
Public Types inherited from IInterface
enum | Status : StatusCode::code_t { Status::FAILURE = 0, Status::SUCCESS = 1, Status::NO_INTERFACE, Status::VERSMISMATCH, Status::LAST_ERROR }
| Return status. More...
using | iid = Gaudi::InterfaceId< IInterface, 0, 0 >
| Interface ID. More...
using | ext_iids = Gaudi::interface_list< iid >
| Extra interfaces. More...
Static Public Member Functions inherited from IInterface
static const InterfaceID & | interfaceID ()
| Return an instance of InterfaceID identifying the interface. More...

## Detailed Description

Definition of a interface for a generic random number generators.

Author
  M.Frank

Version
  1.0

Definition at line 34 of file IRndmGen.h.

## Constructor & Destructor Documentation

## ◆ ~IRndmGen()

virtual IRndmGen::~IRndmGen | ( |  | ) |
| virtual default

Virtual destructor.

## Member Function Documentation

## ◆ DeclareInterfaceID()

IRndmGen::DeclareInterfaceID | ( | IRndmGen | ,
|  | 2 | ,
|  | 0 |
| ) |  |

InterfaceID.

## ◆ finalize()

virtual StatusCode IRndmGen::finalize | ( |  | ) |
| pure virtual

Finalize the generator.

## ◆ ID()

virtual long IRndmGen::ID | ( |  | ) | const
| pure virtual

Random generator ID.

## ◆ initialize()

virtual StatusCode IRndmGen::initialize | ( | const IRndmGen::Param & | par | ) |
| pure virtual

Initialize the generator.

## ◆ parameters()

virtual const IRndmGen::Param* IRndmGen::parameters | ( |  | ) | const
| pure virtual

Access to random number generator parameters.

## ◆ shoot()

virtual double IRndmGen::shoot | ( |  | ) | const
| pure virtual

Single shot returning single random number according to specified distribution.

## ◆ shootArray()

virtual StatusCode IRndmGen::shootArray | ( | std::vector< double > & | array,
|  | long | howmany,
|  | long | start = `0`
| ) |  | const
| pure virtual

Multiple shots returning vector with random number according to specified distribution.

Parameters

  array | Array containing random numbers
  howmany | fill 'howmany' random numbers into array
  start | ... starting at position start
  Statuscode | indicating success or failure

## ◆ type()

virtual const InterfaceID& IRndmGen::type | ( |  | ) | const
| pure virtual

Random number generator type.

The documentation for this class was generated from the following file:

- GaudiKernel/GaudiKernel/IRndmGen.h